package com.ruoyi.service.impl;

import com.ruoyi.domain.Task;
import com.ruoyi.service.CarReviewTaskService;
import com.ruoyi.service.SystemReviewTaskService;
import com.ruoyi.service.TaskService;
import com.ruoyi.service.TaskState;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Objects;

@Component
public abstract class TaskStateAdapter implements TaskState {

    @Autowired
    private SystemReviewTaskService systemReviewTaskService;

    @Autowired
    private CarReviewTaskService carReviewTaskService;

    @Autowired
    private TaskService taskService;
    @Override
    public void doStart(Task task) {

        task.setTaskStatus(Task.TASK_STATUS_PENDING);
        task.setRunStatus(Task.RUN_STATUS_STATUS_RUNNING);

        if (Objects.equals(task.getNextNode(), Task.SUB_TASK_SRAIF)) {
            systemReviewTaskService.start(task.getSystemReviewTaskId());
            task.setNextNode(Task.SUB_TASK_GRFIS);
            taskService.updateById(task);

        } else if (Objects.equals(task.getNextNode(), Task.SUB_TASK_GRFIS)) {
            carReviewTaskService.startReviewTask(task.getCarReviewTaskId());
            task.setNextNode(Task.SUB_TASK_TRFIS);
            taskService.updateById(task);

        }

    }
}
